#include <windows.h>
#include "ddemlsr.h"
#include "ddemlfn.h"

LRESULT WINAPI WndProc( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

char const szClassName[]   = "DDEMLSERVER";  //  
char const szWindowTitle[] = "DDEML Server"; //  

//  
HWND hWnd;
HINSTANCE hInst;
LPSTR szData;


int WINAPI WinMain(HINSTANCE hInstance,     //  
                   HINSTANCE hPrevInstance, //   
                   LPSTR lpszCmdParam,      //  
                   int nCmdShow)            //  

{ WNDCLASS WndClass;   //   
  MSG Msg;             //  ""

  hInst=hInstance;

  // ,       
  hWnd = FindWindow(szClassName,szWindowTitle);
  if (hWnd) { if (IsIconic(hWnd)) ShowWindow(hWnd,SW_RESTORE);
               SetForegroundWindow(hWnd);
               return false; }

  /*    */
  WndClass.style = CS_HREDRAW | CS_VREDRAW; //  
  WndClass.lpfnWndProc = WndProc; //    !
  WndClass.cbClsExtra = 0; WndClass.cbWndExtra = 0;
  WndClass.hInstance = hInstance; //  
  WndClass.hIcon   = LoadIcon(hInstance,"SERVER_ICON"); // 
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);  //  
  WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
  WndClass.lpszMenuName = "SERVER_MENU"; //   
  WndClass.lpszClassName = szClassName; //   

  /*    */
  if (! RegisterClass(&WndClass) )
  { MessageBox(NULL,"Cannot register class","Server",MB_OK);
    return 1;
  }

  /*   */
  hWnd = CreateWindow(szClassName, //   
  							 szWindowTitle, //   ( )
         WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU |
         WS_MINIMIZEBOX | WS_BORDER, //  
                        0,   0, // X,Y 
                      200, 200, // , 
                      NULL, //   
                      NULL, //   ( )
                      hInstance, //  
                      NULL); //    

 if (!hWnd)
 { MessageBox(NULL,"Cannot create Window","Server",MB_OK);
   return 2; //  ,     
 }

 ShowWindow(hWnd,SW_SHOWNORMAL); //  
 UpdateWindow(hWnd);

 /*       WM_QUIT */
 while (GetMessage(&Msg, //   
                   NULL, //  ,  NULL,     
                   0,0)) //   ( 0,0,  )
 {
  TranslateMessage(&Msg); //     
  DispatchMessage(&Msg);  //  
 }
 return Msg.wParam; //   ,   WM_QUIT
}


/*   */
LRESULT WINAPI WndProc( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{ HDC hDC;
  PAINTSTRUCT ps;
  static char s[256];

  switch (Message)
  { case WM_CREATE  :      //  DDEML
      DDEServerOpen(hInst, (HWND) hWnd, (LPSTR) "BMPServer",
        (LPSTR) "BMPFile", (LPSTR) "DDEData");
      return 0;

    case WM_COMMAND :
     switch LOWORD(wParam)
     { case CM_HELPABOUT:
         MessageBox(hWnd,"DDEML Server\n Version 1.0","About",
                    MB_OK | MB_ICONINFORMATION);
         break;
       case CM_FILEEXIT:
         DestroyWindow(hWnd);
         break;
       case CM_REPAINT:
         strcpy(s,(char *) lParam);
         InvalidateRect(hWnd,NULL,true);
         break;
     }
     return 0;

    case WM_PAINT:
     hDC=BeginPaint(hWnd,&ps);
     TextOut(hDC,0,0,s,strlen(s));
     EndPaint(hWnd,&ps);
     return 0;

    case WM_DESTROY :
      DDEServerClose();
      PostQuitMessage(0); //     WM_QUIT
   	return 0;           //   ,    0

    default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}
